> ## Documentation Index
> Fetch the complete documentation index at: https://docs.diversion.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# Create draft commit

> Create a draft commit from workspace changes, optionally with a review



## OpenAPI

````yaml post /repos/{repo_id}/workspaces/{workspace_id}/commit-draft
openapi: 3.0.3
info:
  title: Diversion Core API
  description: >-
    Definition of the Core API used to access low-level functionality of
    Diversion
  version: 0.2.0
servers:
  - url: https://api.diversion.dev/v0
    description: Base endpoint
security: []
paths:
  /repos/{repo_id}/workspaces/{workspace_id}/commit-draft:
    parameters:
      - $ref: '#/components/parameters/RepoParam'
      - $ref: '#/components/parameters/WorkspaceParam'
    post:
      tags:
        - Repository Workspace Manipulation
      summary: Create draft commit
      description: Create a draft commit from workspace changes, optionally with a review
      operationId: src.handlersv2.workspace.commit_as_draft
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CommitAsDraftRequest'
      responses:
        '201':
          description: Draft commit created successfully
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CommitAsDraftResponse'
        '400':
          description: Bad request (no changes to commit)
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        default:
          $ref: '#/components/responses/Error'
      security:
        - OAuth2:
            - coreapi/write
components:
  parameters:
    RepoParam:
      in: path
      name: repo_id
      required: true
      schema:
        type: string
        example: example_id
        minLength: 3
        maxLength: 128
      description: >-
        The repo ID of the repository. Repo _name_ can be used instead of the
        ID, but usage of ID for permanent linking and API requests is preferred.
    WorkspaceParam:
      in: path
      name: workspace_id
      required: true
      schema:
        type: string
        example: example_id
        minLength: 3
        maxLength: 128
      description: The repo ID of the workspace.
  schemas:
    CommitAsDraftRequest:
      type: object
      properties:
        message:
          type: string
          description: Commit message for the draft
        title:
          type: string
          description: Title for the review (defaults to message)
        description:
          type: string
          description: Description for the review
        reviewer_ids:
          type: array
          items:
            type: string
          description: User IDs of reviewers to assign
        include_paths:
          $ref: '#/components/schemas/PathsList'
    CommitAsDraftResponse:
      type: object
      properties:
        review_id:
          type: string
          description: Associated review ID if created
    Error:
      type: object
      properties:
        status:
          type: integer
          description: HTTP status code
        detail:
          type: string
        title:
          type: string
        type:
          type: string
      required:
        - status
        - detail
    PathsList:
      description: >-
        Inclusion list of paths to include in the operation. If `null`, all
        paths will be included.
      type: array
      nullable: true
      minItems: 1
      items:
        type: string
        description: A relative path to a file or directory inside the repository.
        minLength: 1
  responses:
    Error:
      description: An error occurred
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
  securitySchemes:
    OAuth2:
      type: oauth2
      x-tokenInfoFunc: src.token_info.token_auth
      description: This API uses OAuth 2 with the implicit grant flow
      flows:
        implicit:
          authorizationUrl: https://auth.diversion.dev/oauth2/authorize
          scopes:
            coreapi/read: Operations with no possible side-effects
            coreapi/write: Modifying operations
            coreapi/admin: >-
              Organizational operations like adding a repo or changing repo
              properties

````